/*
# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  
*/

/*=========================================================================                                                                               
Program:   bbtk
Module:    $RCSfile$
Language:  C++
Date:      $Date$
Version:   $Revision$
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         



/**
*  \file 
*  \brief Class bbtk::GConnectorController : abstract black-box interface. 
*/

/****
* Design and Developpement of BBTK GEditor
* Ricardo A Corredor J <ra.corredor67@uniandes.edu.co>
* RaC - 2010
****/

#ifndef __GConnectorController_h__
#define __GConnectorController_h__

//Includes same project
#include "GConnectorModel.h"
#include "GObjectController.h"
#include "manualConnectorContourView.h"
#include "manualConnectorContourController.h"

//Includes creaMaracasVisu

//Includes std
#include <iostream>



namespace bbtk
{

	class GConnectorController : public GObjectController
	{

	public: 

		//Constructors
		GConnectorController();
		~GConnectorController();
		
		//Public methods

		// Methods from InteractorStyleMaracas
		virtual bool  OnMouseMove();
		virtual bool  OnLeftButtonDown(); 
		virtual bool  OnLeftButtonUp();
		virtual bool  OnLeftDClick();
		virtual bool  OnRightButtonDown();
		virtual bool  OnRightButtonUp();
		virtual bool  OnMiddleButtonDown();
		virtual bool  OnMiddleButtonUp();

		// Implementation of the creaMaracasVisu controller
		manualConnectorContourController* getManualContourController();
		void setManualContourController(manualConnectorContourController* controller);

		virtual void removeFromScene();

		// Reports the end in the contour creation
		void endContourCreation();

	private:

		//Attributes

		// Implementation of the creaMaracasVisu contour (manualContourControler) controller
		manualConnectorContourController* _controller;

		//Private Methods

	protected:
		//Protected methods
		
	};


}
// namespace bbtk
#endif

